package pku.edu.hocra;

import pku.edu.hocra.resource.Constants;
import pku.edu.hocra.resource.FileManager;
import soot.PackManager;
import soot.SceneTransformer;
import soot.Transform;

public class DriverSubject {

	private static void start(SceneTransformer stf, String mainMethodStr) {

		soot.G.reset();
		PackManager.v().getPack("wjtp").add(new Transform("wjtp.client", stf));
		
		String jreLibPrefix = Constants.jrePath;
		String sp = Constants.sep;
		String specPathPrefix = Constants.specPath;
		String[] specJars = Constants.specJars;
		String[] specJarsPath = new String[specJars.length];
		for (int i = 0; i < specJarsPath.length; i++)
			specJarsPath[i] = specPathPrefix + specJars[i];
		String specJarsPathConcatenation = specJarsPath[0];
		for (int i = 1; i < specJarsPath.length; i++)
			specJarsPathConcatenation += sp + specJarsPath[i];

		String[] sootArgs = new String[] {
				"-w",
				"-include-all",
				"-exclude", "javax.swing.*",
				"-exclude", "java.awt.*",
				"-exclude", "sun.awt.*",
				"-exclude", "sun.swing.*",
				"-exclude", "sun.*",
				"-exclude", "com.sun.*",
				"-no-bodies-for-excluded",
				"-p", "cg.spark", "enabled:true", 
				//"-p", "cg.spark", "verbose:true",
				"-p", "wjtp.client", "enabled:true",
				"-p", "wjap.cgg", "enabled:true",
				"-soot-class-path", 
				"build"+sp+specJarsPathConcatenation
					+sp+jreLibPrefix+"rt.jar"
					+sp+jreLibPrefix+"jce.jar",
				mainMethodStr
				};
		soot.Main.main(sootArgs);
	
	}
	
	public static void main(String[] args) {
		
		FileManager.makeDir("dddata/subjects");
		
		for (int i = 0; i < Constants.subjectNames.length; i++) {
			start(new WholeProgramTransformer(Constants.subjectNames[i]), Constants.benchmarks[i]);
		}
		
	}
	
}
