package pku.edu.hocra.graph.ds;

import java.util.HashMap;
import java.util.Map;

public class MutualMap<T1, T2> {
	
	protected Map<T1, T2> k2v = new HashMap<T1, T2>();
	protected Map<T2, T1> v2k = new HashMap<T2, T1>();
	
	public boolean put(T1 key, T2 value) {
		if (k2v.containsKey(key) || v2k.containsKey(value))
			return false;
		k2v.put(key, value);
		v2k.put(value, key);
		return true;
	}
	
	public T1 getKey(T2 value) {
		return v2k.get(value);
	}
	
	public T2 getValue(T1 key) {
		return k2v.get(key);
	}
	
	public boolean containsKey(T1 key) {
		return k2v.containsKey(key);
	}
	
}
