package pku.edu.hocra.jimple;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeSet;

import pku.edu.hocra.resource.Constants;

public class DriverJimple {

	public static void main(String[] args) throws IOException {
		
		String jreLibPrefix = Constants.jrePath;
		String specPathPrefix = Constants.specPath;
		String sp = Constants.sep;
		String[] specJars = Constants.specJars;
		String[] specJarsPath = new String[specJars.length];
		for (int i = 0; i < specJarsPath.length; i++)
			specJarsPath[i] = specPathPrefix + specJars[i];
		String specJarsPathConcatenation = specJarsPath[0];
		for (int i = 1; i < specJarsPath.length; i++)
			specJarsPathConcatenation += sp + specJarsPath[i];
		specJarsPathConcatenation += sp + specPathPrefix + "lib/xercesImpl.jar";
		String fullPath = "bin"+sp+specJarsPathConcatenation
				+sp+jreLibPrefix+"rt.jar"
				+sp+jreLibPrefix+"jce.jar";

		PrintStream ps = new PrintStream(new FileOutputStream("dddata\\loc.dat"));
		Set<String> libraryClasses = new HashSet<String>();
		ps.println("library");
		calculateLOC("dddata\\library\\LibraryMethod.dat", fullPath, true, ps, libraryClasses);
		for (String sname : Constants.subjectNames) {
			ps.println("------------\n" + sname);
			calculateLOC("dddata\\subjects\\" + sname + "\\SubjectMethod.dat", fullPath, false, ps, libraryClasses);
		}
		ps.close();
		
	}
	
	public static void calculateLOC(String methodFile, String fullPath, boolean libraryMode, PrintStream ps, Set<String> libraryClasses) 
			throws IOException {
		
		Scanner sc = new Scanner(new FileInputStream(methodFile));
				
		Set<String> set4class = new TreeSet<String>();
		while (sc.hasNextLine()) {
			String line = sc.nextLine();
			int ed = line.indexOf(":");
			String classname = line.substring(1, ed);
			set4class.add(classname);
			if (libraryMode)
				libraryClasses.add(classname);
		}
		
		soot.G.reset();
		String[] sootArgs = new String[set4class.size()+4];
		sootArgs[0] = "-soot-class-path";
		sootArgs[1] = fullPath;
		int i = 2;
		for (String classname : set4class) {
			sootArgs[i++] = classname;
		}
		sootArgs[sootArgs.length-2] = "-f";
		sootArgs[sootArgs.length-1] = "J";
		soot.Main.main(sootArgs);
		
		int tot = 0, cli = 0;
		for (String className : set4class) {
			BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream("sootOutput\\"+className+".jimple")));
			int s = 0;
			while (br.readLine() != null) 
				s ++;
			br.close();
			tot += s;
			if (!libraryMode && !libraryClasses.contains(className))
				cli += s;
		}
		if (libraryMode)
			ps.println(tot);
		else
			ps.println(tot + " " + cli);
		
	}
	
	
}
