package pku.edu.hocra.resource;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

public class Constants {

	public static String jrePath = null;
	public static String sep = null;
	public static final String specPath = "SPECjvm2008/";
	public static final String[] specJars = new String[] {
		"SPECjvm2008.jar",
		"lib/check.jar", "lib/derby.jar", "lib/jl1.0.jar", "lib/jcommon-1.0.9.jar", 
		"lib/jfreechart-1.0.5.jar", "lib/janino.jar", "lib/sunflow.jar", "lib/Tidy.jar",
		"lib/ant-launcher.jar", "lib/ant.jar", "lib/javac.jar", "lib/xom-1.1.jar"
	};
	public static final String dacapoPath = "Dacapo/dacapo-9.12-bach.jar";
	public static String[] benchmarks = new String[] {
		"pku.edu.hocra.tests.CheckBenchmark",
		"pku.edu.hocra.tests.CompilerBenchmark",
		"pku.edu.hocra.tests.CompressBenchmark",
		"pku.edu.hocra.tests.CryptoBenchmark",
		"pku.edu.hocra.tests.DerbyBenchmark",
		"pku.edu.hocra.tests.HelloworldBenchmark",
		"pku.edu.hocra.tests.MpegaudioBenchmark",
		"pku.edu.hocra.tests.ScimarkBenchmark",
		"pku.edu.hocra.tests.SerialBenchmark",
		"pku.edu.hocra.tests.StartupBenchmark",
		"pku.edu.hocra.tests.SunflowBenchmark",
		"pku.edu.hocra.tests.XmlBenchmark"
	};
	public static String[] subjectNames = new String[] {
		"check",
		"compiler",
		"compress",
		"crypto",
		"derby",
		"helloworld",
		"mpegaudio",
		"scimark",
		"serial",
		"startup",
		"sunflow",
		"xml"
	};
	
	static {
		try {
			FileInputStream fis = new FileInputStream("config.txt");
			BufferedReader br = new BufferedReader(new InputStreamReader(fis));
			for (String line; (line = br.readLine()) != null; ) {
				String[] kv = line.split("=");
				switch (kv[0]) {
				case "jrePath" : jrePath = kv[1]; break;
				case "sep" : sep = kv[1]; break;
				}
			}
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
}
