package pku.edu.hocra.statistics;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashSet;
import java.util.Set;

import pku.edu.hocra.resource.Constants;

public class DriverStatistics {
	
	
	public static void main(String[] args) throws IOException {
		
		Set<String> libraryMethodSet = new HashSet<String>(); 
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream("dddata\\library\\LibraryMethod.dat")));
		int numOfLibraryMethods = 0;
		int numOfLibraryNodes = 0;
		while (true) {
			String line = br.readLine();
			if (line == null) break;
			numOfLibraryNodes += Integer.valueOf(line.split(";")[2]);
			numOfLibraryMethods ++;
			libraryMethodSet.add(line.split(";")[0]);
		}
		br.close();
		br = new BufferedReader(new InputStreamReader(new FileInputStream("dddata\\library\\LibraryGraph.dat")));
		int numOfLibraryEdges = 0;
		Set<Integer> setCb = new HashSet<Integer>();
		Set<Integer> setVc = new HashSet<Integer>();
		while (true) {
			String line = br.readLine();
			if (line == null) break;
			numOfLibraryEdges ++;
			String[] sa = line.split(" ");
			if (sa.length == 4) {
				if (sa[2].equals("C"))
					setCb.add(Integer.valueOf(sa[3]));
				if (sa[2].endsWith("V"))
					setVc.add(Integer.valueOf(sa[3]));
			}
		}
		System.out.println("# of Methods: " + numOfLibraryMethods);
		System.out.println("# of Nodes: " + numOfLibraryNodes);
		System.out.println("# of Edges: " + numOfLibraryEdges);
		System.out.println("# of Virtual Call Premises: " + setVc.size());
		System.out.println("# of Call-back Premises: " + setCb.size());
		
		for (String subject : Constants.subjectNames) {
			System.out.println("\n-- " + subject + " --");
			int lmethod = 0, cmethod = 0, lnode = 0, cnode = 0;
			br = new BufferedReader(new InputStreamReader(new FileInputStream("dddata\\subjects\\" + subject + "\\SubjectMethod.dat")));
			while (true) {
				String line = br.readLine();
				if (line == null) break;
				String[] sa = line.split(";");
				String methodName = sa[0];
				int nodeNum = Integer.valueOf(sa[2]);
				if (libraryMethodSet.contains(methodName)) {
					lmethod ++;
					lnode += nodeNum;
				}	
				else {
					cmethod ++;
					cnode += nodeNum;
				}
			}
			System.out.println(cnode + " " + lnode + " " + (cnode+lnode));
			System.out.println(cmethod + " " + lmethod + " " + (cmethod+lmethod));
		}
		
		
	}

}
